﻿namespace Netina.Api.Controllers;

public class CustomerController : ICarterModule
{
    public void AddRoutes(IEndpointRouteBuilder app)
    {
        var group = app.NewVersionedApi("Customer").MapGroup("api/customer")
            .RequireAuthorization(builder=>builder.AddAuthenticationSchemes("Bearer").RequireAuthenticatedUser());

        group.MapGet("", GetCustomersAsync)
            .WithDisplayName("Get Customers")
            .HasApiVersion(1.0);
    }

    private async Task<IResult> GetCustomersAsync([FromQuery] int page, [FromQuery] int? count, [FromServices] IMediator mediator, CancellationToken cancellationToken)
        => TypedResults.Ok(true);
}