﻿namespace Netina.Domain.CommandQueries.Commands;

public sealed record CreateCommentCommand(
    string Title,
    string Content,
    float Rate,
    bool IsBuyer,
    bool IsAdmin,
    Guid? ParentId,
    Guid? BlogId = null,
    Guid? ProductId = null,
    Guid? UserId = null) : IRequest<Guid>;

public sealed record UpdateCommentCommand(
    Guid Id,
    string Title,
    string Content,
    float Rate,
    bool IsBuyer,
    bool IsAdmin,
    Guid? ParentId,
    Guid? BlogId = null,
    Guid? ProductId = null,
    Guid? UserId = null) : IRequest<Guid>;

public sealed record ConfirmCommentCommand(Guid Id) : IRequest<Guid>;
public sealed record DeleteCommentCommand(Guid Id) : IRequest<Guid>;