﻿namespace Netina.Domain.CommandQueries.Commands;


public sealed record CreateSubProductCommand(
    Guid ParentId,
    ProductDiversity Diversity,
    string DiversityValue,
    string DiversityDescription,
    string PersianName,
    double Cost,
    double PackingCost,
    int Stock,
    bool HasExpressDelivery,
    int MaxOrderCount,
    List<StorageFileSDto> Files) : IRequest<Guid>;

public sealed record UpdateSubProductCommand(
    Guid Id,
    Guid ParentId,
    ProductDiversity Diversity,
    string DiversityValue,
    string DiversityDescription,
    string PersianName,
    double Cost,
    double PackingCost,
    int Stock,
    bool HasExpressDelivery,
    int MaxOrderCount,
    List<StorageFileSDto> Files) : IRequest<Guid>;

public sealed record DeleteSubProductCommand(Guid Id) : IRequest<bool>;