﻿using Netina.Domain.Entities.Comments;

namespace Netina.Domain.Entities.Products;

[AdaptTwoWays("[name]LDto", IgnoreAttributes = [typeof(AdaptIgnoreAttribute)], MapType = MapType.Map | MapType.MapToTarget | MapType.Projection)]
[AdaptTwoWays("[name]SDto", IgnoreAttributes = [typeof(AdaptIgnoreAttribute)], MapType = MapType.Map | MapType.MapToTarget )]
[AdaptTo("[name]SDto", IgnoreAttributes = [typeof(AdaptIgnoreAttribute)], MapType = MapType.Projection)]
[AdaptTo("TorobProductResponseDto", IgnoreAttributes = [typeof(AdaptIgnoreAttribute)], MapType = MapType.Projection)]
//[AdaptTo("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Projection)]
[GenerateMapper]


//[Index(nameof(Slug), IsUnique = true)]
public partial class Product : ApiEntity
{
    public Product()
    {

    }

    public Product(
        string persianName,
        string englishName,
        string slug,
        string summery,
        string expertCheck,
        string tags,
        string warranty,
        bool beDisplayed,
        double cost,
        double packingCost, 
        int stock,
        bool hasExpressDelivery,
        int maxOrderCount,
        bool isEnable,
        bool isSubProduct,
        Guid brandId,
        Guid categoryId,
        Guid authorId)
    {
        PersianName = persianName;
        EnglishName = englishName;
        Slug = slug;
        Summery = summery;
        ExpertCheck = expertCheck;
        Tags = tags;
        Warranty = warranty;
        BeDisplayed = beDisplayed;
        Cost = cost;
        PackingCost = packingCost;
        Stock = stock;
        HasExpressDelivery = hasExpressDelivery;
        MaxOrderCount = maxOrderCount;
        IsEnable = isEnable;
        IsSubProduct = isSubProduct;
        BrandId = brandId;
        CategoryId = categoryId;
        AuthorId = authorId;
    }
    public string PersianName { get; internal set; } = string.Empty;
    public string EnglishName { get; internal set; } = string.Empty;
    public string Slug { get; internal set; } = string.Empty;
    public string Summery { get; internal set; } = string.Empty;
    public string ExpertCheck { get; internal set; } = string.Empty;
    public string Tags { get; internal set; } = string.Empty;
    public string Warranty { get; internal set; } = string.Empty;
    public double Cost { get; internal set; }
    public bool IsEnable { get; internal set; }
    public bool BeDisplayed { get; internal set; }
    public double PackingCost { get; internal set; }
    public int Stock { get; internal set; }
    public float Rate { get; internal set; }
    public int ReviewCount { get; internal set; }
    public int Viewed { get; internal set; }
    public bool HasExpressDelivery { get; internal set; }
    public int MaxOrderCount { get; internal set; }
    public bool IsSubProduct { get; internal set; }
    public Guid BrandId { get; internal set; }
    public Brand? Brand { get; internal set; }
    
    public Guid CategoryId { get; internal set; }
    public Guid AuthorId { get; internal set; }
    public ApplicationUser? Author { get; internal set; }
    public ProductCategory? Category { get; internal set; }

    public List<Specification> Specifications { get; internal set; } = [];
    public List<SubProduct> SubProducts { get; internal set; } = [];
    public List<ProductMetaTag> MetaTags { get; internal set; } = [];
    public List<ProductStorageFile> Files { get; internal set; } = [];
    public List<ProductComment> Comments { get; internal set; } = [];
    public List<OrderProduct> OrderProducts { get; internal set; } = [];
}