﻿namespace Netina.Domain.Entities.Products;

[AdaptTwoWays("[name]SDto", IgnoreAttributes = [typeof(AdaptIgnoreAttribute)], MapType = MapType.Map | MapType.MapToTarget)]
[GenerateMapper]

public partial class SubProduct : Product
{
    public SubProduct()
    {
        
    }

    public SubProduct(
        Guid parentId,
        ProductDiversity diversity,
        string diversityValue,
        string diversityDescription,
        string persianName,
        string englishName,
        string slug,
        string summery,
        string expertCheck,
        string tags,
        string warranty,
        bool beDisplayed,
        double cost,
        double packingCost,
        int stock,
        bool hasExpressDelivery,
        int maxOrderCount,
        bool isEnable,
        Guid brandId,
        Guid categoryId,
        Guid authorId) : base(persianName,
        englishName,
        slug,
        summery,
        expertCheck,
        tags,
        warranty,
        beDisplayed,
        cost,
        packingCost,
        stock,
        hasExpressDelivery,
        maxOrderCount,
        isEnable,
        true,
        brandId,
        categoryId,
        authorId)
    {
        ParentId = parentId;
        Diversity = diversity;
        DiversityValue = diversityValue;
        DiversityDescription = diversityDescription;
    }

    public Guid? ParentId { get; internal set; }
    public Product? Parent { get; internal set; }

    public ProductDiversity Diversity { get; internal set; }
    public string DiversityValue { get; internal set; } = string.Empty;
    public string DiversityDescription { get; internal set; } = string.Empty;
}