using System;
using System.Linq.Expressions;
using Netina.Domain.Dtos.SmallDtos;
using Netina.Domain.Entities.Seo;

namespace Netina.Domain.Mappers
{
    public static partial class MetaTagMapper
    {
        public static MetaTag AdaptToMetaTag(this MetaTagSDto p1)
        {
            return p1 == null ? null : new MetaTag()
            {
                Type = p1.Type,
                Value = p1.Value,
                Id = p1.Id,
                CreatedAt = p1.CreatedAt
            };
        }
        public static MetaTag AdaptTo(this MetaTagSDto p2, MetaTag p3)
        {
            if (p2 == null)
            {
                return null;
            }
            MetaTag result = p3 ?? new MetaTag();
            
            result.Type = p2.Type;
            result.Value = p2.Value;
            result.Id = p2.Id;
            result.CreatedAt = p2.CreatedAt;
            return result;
            
        }
        public static MetaTagSDto AdaptToSDto(this MetaTag p4)
        {
            return p4 == null ? null : new MetaTagSDto()
            {
                Type = p4.Type,
                Value = p4.Value,
                Id = p4.Id,
                CreatedAt = p4.CreatedAt
            };
        }
        public static MetaTagSDto AdaptTo(this MetaTag p5, MetaTagSDto p6)
        {
            if (p5 == null)
            {
                return null;
            }
            MetaTagSDto result = p6 ?? new MetaTagSDto();
            
            result.Type = p5.Type;
            result.Value = p5.Value;
            result.Id = p5.Id;
            result.CreatedAt = p5.CreatedAt;
            return result;
            
        }
        public static Expression<Func<MetaTag, MetaTagSDto>> ProjectToSDto => p7 => new MetaTagSDto()
        {
            Type = p7.Type,
            Value = p7.Value,
            Id = p7.Id,
            CreatedAt = p7.CreatedAt
        };
    }
}