﻿namespace Netina.Repository.Handlers.SubProducts;

public class DeleteSubProductCommandHandler(IRepositoryWrapper repositoryWrapper)
    : IRequestHandler<DeleteSubProductCommand, bool>
{
    public async Task<bool> Handle(DeleteSubProductCommand request, CancellationToken cancellationToken)
    {
        var ent = await repositoryWrapper.SetRepository<SubProduct>().TableNoTracking
            .FirstOrDefaultAsync(d => d.Id == request.Id, cancellationToken);
        if (ent == null)
            throw new AppException("Product NotFound", ApiResultStatusCode.NotFound);

        repositoryWrapper.SetRepository<Product>().Delete(ent);
        await repositoryWrapper.SaveChangesAsync(cancellationToken);
        return true;
    }
}