﻿namespace Netina.Repository.Handlers.SubProducts;

public class GetSubProductsQueryHandler(IRepositoryWrapper repositoryWrapper) : IRequestHandler<GetSubProductsQuery,List<SubProductSDto>>
{
    public async Task<List<SubProductSDto>> Handle(GetSubProductsQuery request, CancellationToken cancellationToken)
    {
        var product = await repositoryWrapper.SetRepository<Product>().TableNoTracking
            .FirstOrDefaultAsync(p => p.Id == request.ProductId, cancellationToken);
        if (product == null)
            throw new AppException("Product not found");

        return await repositoryWrapper.SetRepository<SubProduct>().TableNoTracking
            .Where(s => s.ParentId == request.ProductId)
            .Select(SubProductMapper.ProjectToSDto)
            .ToListAsync(cancellationToken);
    }
}