﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace NetinaShop.Repository.Migrations
{
    /// <inheritdoc />
    public partial class AddProductMetaTag : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<Guid>(
                name: "ProductId",
                schema: "public",
                table: "MetaTags",
                type: "uuid",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_MetaTags_ProductId",
                schema: "public",
                table: "MetaTags",
                column: "ProductId");

            migrationBuilder.AddForeignKey(
                name: "FK_MetaTags_Products_ProductId",
                schema: "public",
                table: "MetaTags",
                column: "ProductId",
                principalSchema: "public",
                principalTable: "Products",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_MetaTags_Products_ProductId",
                schema: "public",
                table: "MetaTags");

            migrationBuilder.DropIndex(
                name: "IX_MetaTags_ProductId",
                schema: "public",
                table: "MetaTags");

            migrationBuilder.DropColumn(
                name: "ProductId",
                schema: "public",
                table: "MetaTags");
        }
    }
}
