﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace NetinaShop.Repository.Migrations
{
    /// <inheritdoc />
    public partial class AddMetaTagToBlogAndBrands : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<Guid>(
                name: "BlogId",
                schema: "public",
                table: "MetaTags",
                type: "uuid",
                nullable: true);

            migrationBuilder.AddColumn<Guid>(
                name: "BrandId",
                schema: "public",
                table: "MetaTags",
                type: "uuid",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_MetaTags_BlogId",
                schema: "public",
                table: "MetaTags",
                column: "BlogId");

            migrationBuilder.CreateIndex(
                name: "IX_MetaTags_BrandId",
                schema: "public",
                table: "MetaTags",
                column: "BrandId");

            migrationBuilder.AddForeignKey(
                name: "FK_MetaTags_Blogs_BlogId",
                schema: "public",
                table: "MetaTags",
                column: "BlogId",
                principalSchema: "public",
                principalTable: "Blogs",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);

            migrationBuilder.AddForeignKey(
                name: "FK_MetaTags_Brands_BrandId",
                schema: "public",
                table: "MetaTags",
                column: "BrandId",
                principalSchema: "public",
                principalTable: "Brands",
                principalColumn: "Id",
                onDelete: ReferentialAction.Restrict);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_MetaTags_Blogs_BlogId",
                schema: "public",
                table: "MetaTags");

            migrationBuilder.DropForeignKey(
                name: "FK_MetaTags_Brands_BrandId",
                schema: "public",
                table: "MetaTags");

            migrationBuilder.DropIndex(
                name: "IX_MetaTags_BlogId",
                schema: "public",
                table: "MetaTags");

            migrationBuilder.DropIndex(
                name: "IX_MetaTags_BrandId",
                schema: "public",
                table: "MetaTags");

            migrationBuilder.DropColumn(
                name: "BlogId",
                schema: "public",
                table: "MetaTags");

            migrationBuilder.DropColumn(
                name: "BrandId",
                schema: "public",
                table: "MetaTags");
        }
    }
}
